package MyWebApp.Beans;

import MyWebApp.Tools.ImgGenerator;
import com.sun.msv.reader.Controller;
import org.primefaces.model.DefaultStreamedContent;
import org.primefaces.model.StreamedContent;

import javax.annotation.PostConstruct;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ApplicationScoped;
import javax.imageio.ImageIO;
import javax.inject.Inject;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.Serializable;

@ManagedBean(name="ViewBean")
@ApplicationScoped
public class ViewBean implements Serializable
{
    @ManagedProperty(value="#{HistoryBean}")
    private HistoryBean historyBean;

    private StreamedContent image;

    @ManagedProperty(value="#{ControllerBean}")
    private ControllerBean controllerBean;

    public void setControllerBean(ControllerBean controllerBean) {
        this.controllerBean = controllerBean;
    }

    private String htmlTable;
    private float imageWidht;

    private float imageHeight;
    private static final String inAreaMSG = "Попадание";


    private static final String outAreaMSG = "Промах";
    private static final String TableFirstSTR ="<td>X</td> <td>Y</td> <td> R </td> <td>Result</td>";

    @PostConstruct
    public void init()
    {
        imageWidht  = 400;
        imageHeight = 400;
    }

    public String getHtmlTable() {
        htmlTable = genHTMLTable();
        return htmlTable;
    }

    public void setImage(StreamedContent image) {
        this.image = image;
    }

    public StreamedContent getImage() {
        setImage(gnImage());
        return image;
    }



    public void setHistoryBean(HistoryBean historyBean) {
        this.historyBean = historyBean;
    }

    public void setImageWidht(float imageWidht) {
        this.imageWidht = imageWidht;
    }

    public void setImageHeight(float imageHeight) {
        this.imageHeight = imageHeight;
    }

    StreamedContent gnImage()
    {
        DefaultStreamedContent result = null;
        try
        {
            ByteArrayOutputStream os = new ByteArrayOutputStream();
            BufferedImage img = ImgGenerator.genImage(historyBean.toArray(), imageWidht, imageHeight, controllerBean.getCurrentR());

            ImageIO.write(img, "png", os);

            result = new DefaultStreamedContent(new ByteArrayInputStream(os.toByteArray()), "image/png");
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        return result;
    }

    String genHTMLTable()
    {
        StringBuilder build = new StringBuilder();
        build.append("<table>");
        build.append("<tr>" + TableFirstSTR + "</tr>");
        for(HistoryItem item : historyBean.toArray())
        {
            build.append("<tr>");
            build.append("<td>" + item.getX() + "</td><td>" + item.getY() + "</td> <td>" + item.getR() + "</td>");
            build.append("<td>" + (item.getResult()?inAreaMSG:outAreaMSG) +"</td>");
            build.append("</tr>");
        }
        build.append("</table>");
        return build.toString();
    }
}
