package RegLocation.Server;


import RegLocation.Lib.Request;
import RegLocation.Lib.Response;
import RegLocation.Lib.SilhouetteChannel;

import java.io.IOException;
import java.net.Socket;
import java.util.concurrent.Callable;

public class SilhouetteProcThread extends  Thread
{
    ClientSession consumer;
    Request request;
    public SilhouetteProcThread(ClientSession rconsumer,Request rrequest)
    {
        request = rrequest;
        consumer = rconsumer;
    }

    @Override
    public void run()
    {
        double MarkX = request.MarkX;
        double MarkY = request.MarkY;
        double R     = request.R;
        int MHC      = request.MarkHashCode;
        boolean IRR  = Silhouette.InRegion((float)MarkX,(float)MarkY,(float)R);

        consumer.saveResponse(new Response(MHC, IRR, R));
    }
}
